/*
 *	MacRuntime.h
 *
 * Portions copyright American Telephone & Telegraph
 * Used with permission, Apple Computer Inc. (1985,1988,1990,1992-1994)
 * All rights reserved.
 *
 * Warning:  This interface is NOT a part of the ANSI C standard.
 *			 We do NOT claim to be POSIX compliant.
 *			 If you want your code to be portable, don't use this interface.
 */

/* Conditional Macros:
 *	UsingStaticLibs	- for CFM-68K:  Insures that #pragma lib_export is never used.
 *	UsingSharedLibs	- for CFM-68K:  Insures that all functions and data items are
 *									marked as exported
 *	<none>			- for CFM-68K:	Data items are exported using #pragma lib_export,
 *									functions are not.  Causes excess code to be
 *									generated for data references to static libraries
 *									and causes the linker to generate glue for
 *									references to shared library routines.
 *	The preceeding macros may not both be defined in the same compilation.
 */
 
#ifndef __MACRUNTIME__
#define __MACRUNTIME__	1

#if defined (UsingStaticLibs) && defined (UsingSharedLibs)
	#error "Only one of the conditional macros 'UsingStaticLibs' and 'UsingSharedLibs' may be defined in a compilation"
#endif

#pragma once

#ifndef __TYPES__
#include <types.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

/* Global Variables */

#ifdef __CFM68K__
	#ifndef UsingStaticLibs
		#pragma lib_export on
		#define	_EXP_ON_
	#endif
#endif

extern	int	StandAlone;

extern	short	MacOSErr;		/* moved here from errors.h  rjd 941017 */

#ifdef __CFM68K__
	#if !defined(UsingSharedLibs) && defined(_EXP_ON_)
		#pragma lib_export off
		#undef	_EXP_ON_
	#endif
#endif

/* Utility Routines */

pascal Boolean TrapAvailable (short TrapNumber);

#ifdef _EXP_ON_
	#pragma lib_export off
	#undef _EXP_ON_
#endif

#ifdef __cplusplus
}
#endif
#endif