/************************************************************

	Assert.h
	Diagnostics
	
	Copyright  Apple Computer,Inc.  1987-1990, 1994.
	All Rights Reserved.

************************************************************/

#ifdef NDEBUG
	#undef assert
	#define assert(ignore) ((void) 0)
#else

	#ifdef __CFM68K__
		#ifdef UsingSharedLibs
			#pragma lib_export on
			#define	_EXP_ON_
		#endif
	#endif
	#ifdef __cplusplus
		extern "C" {
	#endif
	void __assertprint(const char* file, int line, const char* expr);
	#ifdef __cplusplus
		}
	#endif
	#ifdef __CFM68K__
		#if defined(UsingSharedLibs) && ! defined(_EXP_ON_)
			#pragma lib_export on
		#endif
	#endif
	
	#define assert(expression) \
		( (expression) ? (void) 0 : (__assertprint(__FILE__, __LINE__, #expression)) )

	#ifdef _EXP_ON_
		#undef _EXP_ON_
	#endif
			
#endif
